## -*- coding: utf-8 -*-
## Copyright (C) 2007 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

from Products.Archetypes.BaseObject import BaseObject

from zope.component import adapts
from zope.interface import implements

#Imports for delete
from OFS.ObjectManager import ObjectManager
_getOb = ObjectManager._getOb
_delOb = ObjectManager._delOb
_marker = []

#Patch I18NBaseObject
from AccessControl import ClassSecurityInfo
from Products.LinguaPlone import permissions
from Products.LinguaPlone.I18NBaseObject import I18NBaseObject
from Products.CMFCore.utils import getToolByName
from Products.CMFPlone.utils import base_hasattr
from zope.interface import Interface, classImplements
from zope.app.traversing.adapters import Traverser
from interfaces import ITranslatable

security = ClassSecurityInfo()

security.declareProtected(permissions.View, 'getCanonicalPath')
def getCanonicalPath(self):
    """ Return a path going only through canonical folders.  """
    if base_hasattr(self.aq_inner.aq_parent, 'getCanonicalPath'):
        path = self.aq_inner.aq_parent.getCanonicalPath()
        path += (self.getCanonical().id,)
        return path
    else:
        return self.getCanonical().getPhysicalPath()

security.declareProtected(permissions.AccessContentsInformation, 'myGetTranslations')
def myGetTranslations(self):
    """ Return a table containting all the translations
    """
    languages = self.getTranslationLanguages()
    return [self.getTranslation(language) for language in languages]

security.declareProtected(permissions.AccessContentsInformation, 'getOtherTranslations')
def getOtherTranslations(self):
    """ Return a table containting all the translations
    """
    languages = self.getTranslationLanguages()
    languages.remove(self.getLanguage())
    return [self.getTranslation(language) for language in languages]

I18NBaseObject.getCanonicalPath = getCanonicalPath
I18NBaseObject.myGetTranslations = myGetTranslations
I18NBaseObject.getOtherTranslations = getOtherTranslations
classImplements(I18NBaseObject, ITranslatable)

old__bobo_traverse__ = BaseObject.__bobo_traverse__

def __bobo_traverse__(self, REQUEST, name):
        """Modify the behavior of folder_delete, object_delete, folder_copy
        and folder_cut
        """
        if name not in ("folder_delete", "object_delete", "folder_copy",
                        "folder_cut", "content_status_modify"):
            return old__bobo_traverse__(self, REQUEST, name)

        if name == "folder_delete":
            return getattr(self, "lingua_folder_delete")

        if name == "object_delete":
            return getattr(self, "lingua_object_delete")

        if name == "folder_copy":
            return getattr(self, "lingua_folder_copy")

        if name == "folder_cut":
            return getattr(self, "lingua_folder_cut")

        linguaface_tool = getToolByName(self, 'linguaface_tool')
        if name == "content_status_modify" and linguaface_tool.getProperty('synchronise_translations_workflow'):
            return getattr(self, "lingua_content_status_modify")

I18NBaseObject.__bobo_traverse__ = __bobo_traverse__
