## Script (Python) "folder_position"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=position, id, template_id='folder_contents'
##title=Move objects in a ordered folder
##
from Products.CMFPlone import PloneMessageFactory as _
from Products.CMFPlone.utils import base_hasattr

if base_hasattr(context, 'getCanonicalPath'):
    contents = context.getFolderContents()
    contents = [content for content in contents if content.id == id]
    for content in contents:
        parent = content.getObject().aq_inner.aq_parent

        if position.lower()=='up':
            parent.moveObjectsUp(content.id)

        if position.lower()=='down':
            parent.moveObjectsDown(content.id)

        if position.lower()=='top':
            parent.moveObjectsToTop(content.id)

        if position.lower()=='bottom':
            parent.moveObjectsToBottom(content.id)

        parent.plone_utils.reindexOnReorder(parent)

    msg=_(u'Item\'s position has changed.')
    context.plone_utils.addPortalMessage(msg)
    return state

if position.lower()=='up':
    context.moveObjectsUp(id)

if position.lower()=='down':
    context.moveObjectsDown(id)

if position.lower()=='top':
    context.moveObjectsToTop(id)

if position.lower()=='bottom':
    context.moveObjectsToBottom(id)

# order folder by field
# id in this case is the field
if position.lower()=='ordered':
    context.orderObjects(id)

context.plone_utils.reindexOnReorder(context)

msg=_(u'Item\'s position has changed.')
context.plone_utils.addPortalMessage(msg)

return state