## Script (Python) "getFolderContents"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=contentFilter=None,batch=False,b_size=100,full_objects=False
##title=wrapper method around to use catalog to get folder contents
##
from Products.CMFPlone.utils import base_hasattr
mtool = context.portal_membership
cur_path = '/'.join(context.getPhysicalPath())
path = {}

if not contentFilter:
    # The form and other are what really matters
    contentFilter = dict(getattr(context.REQUEST, 'form',{}))
    contentFilter.update(dict(getattr(context.REQUEST, 'other',{})))
else:
    contentFilter = dict(contentFilter)

if not contentFilter.get('sort_on', None):
    contentFilter['sort_on'] = 'getObjPositionInParent'

if 'InnerContentContainer' in context.portal_types.objectIds():
    if contentFilter.has_key('portal_type'):
        if 'InnerContentContainer' in contentFilter['portal_type']:
            contentFilter['portal_type'].remove('InnerContentContainer')
    else:
        contentFilter['portal_type'] = context.portal_types.objectIds()
        if 'InnerContentContainer' in contentFilter['portal_type']:
            contentFilter['portal_type'].remove('InnerContentContainer')

if contentFilter.get('getCanonicalPath', None) is None:
    canonical_path = \
        base_hasattr(context,'getCanonicalPath') and context.getCanonicalPath()\
        or context.getPhysicalPath()

    path['query'] = '/'.join(canonical_path)
    path['depth'] = 1
    contentFilter['getCanonicalPath'] = path
    contentFilter['Language'] = context.portal_languages.getPreferredLanguage()

show_inactive = mtool.checkPermission('Access inactive portal content', context)

# Evaluate in catalog context because some containers override queryCatalog
# with their own unrelated method (Topics)
contents = context.portal_catalog.queryCatalog(contentFilter, show_all=1,
                                                  show_inactive=show_inactive)
# Get all contents which language is neutral
contentFilter['Language'] = ('',)

# TODO: IMPROVE
# sort by id, getObjPositionInParent is inoperant with neutral/translated content
contentFilter['sort_on'] = 'getId'
neutral_contents = context.portal_catalog.queryCatalog(contentFilter, show_all=1,
                                                  show_inactive=show_inactive)

contents = contents + neutral_contents

if full_objects:
    contents = [b.getObject() for b in contents]

if batch:
    from Products.CMFPlone import Batch
    b_start = context.REQUEST.get('b_start', 0)
    batch = Batch(contents, b_size, int(b_start), orphan=0)
    return batch

return contents